AJS.toInit(function () {
    console.log("wombats_script")
    // All groups view page
    if (window.location.href.indexOf("secure/admin/user/GroupBrowser.jspa") > -1) {
        var oldGroupName = $(".aui-page-header-main h2").text();
    } else
    // One group view page
    if (window.location.href.indexOf("secure/admin/user/ViewGroup.jspa") > -1) {
        var oldGroupName = $(".aui-page-header-main h2").text();
        var button = "<button class='aui-button' onclick='showRenameGroupDialog(&quot;" + oldGroupName + "&quot;);'>Rename</button>";
        $(".aui-page-header-actions .aui-buttons").append(button);
    } 
});

function showRenameGroupDialog(oldGroupName) {
    var template = JIRA.Templates.Wombatscorp.renameGroups({
        oldGroupName: oldGroupName
    });
    AJS.$("body").append(template);
    AJS.dialog2("#rename-group-dialog").show();

    // Bind check
    $("#new-group-name").bind("propertychange change click keyup input paste", function(event) {
        checkName(oldGroupName, $("#new-group-name").val());
    });

    // Bind check
    $("#group-rename-button").click(function(event) {
        rename(oldGroupName, $("#new-group-name").val());
    });
}

var checkNameTimeout = null;
function checkName(oldName, newName) {
    if(!oldName || !newName) {
        $("#group-rename-button").prop('disabled', true);
        $("#new-group-name-error").text("Input data should not be empty");
        $("#new-group-name-error").show();
        return;
    }
     // Clear the timeout if it has already been set.
     // This will prevent the previous task from executing
     clearTimeout(checkNameTimeout);

     // Make a new timeout set to go off in 700ms (0.7 second)
     checkNameTimeout = setTimeout(function () {
     jQuery.ajax({
                 url : AJS.params.baseURL + '/rest/groups/latest/check',
                 type: 'POST',
                 dataType : "json",
                 headers: {"Content-Type":"application/json"},
                 data: '{"oldName":"'+ oldName +'", "newName":"'+ newName +'"}'
             })
           .done(function( data ) {
             if(data.success) {
               $("#group-rename-button").prop('disabled', false);
               $("#new-group-name-error").text("");
               $("#new-group-name-error").hide();
             } else {
               $("#group-rename-button").prop('disabled', true);
               $("#new-group-name-error").text(data.error);
               $("#new-group-name-error").show();
             }
           })
           .fail(function() {
             console.error( "Cannot check rename candidate for the group" );
           });
     }, 700);
}

function rename(oldName, newName) {
    jQuery.ajax({
                 url : AJS.params.baseURL + '/rest/groups/latest/rename',
                 type: 'POST',
                 dataType : "json",
                 headers: {"Content-Type":"application/json"},
                 data: '{"oldName":"'+ oldName +'", "newName":"'+ newName +'"}'
             })
           .done(function( data ) {
             if(data.success) {
                var newUrl = updateURLParameter(window.location.href, "name", newName);
                window.onbeforeunload = null;
                window.location.replace(newUrl);
             } else {
               $("#group-rename-button").prop('disabled', true);
               $("#new-group-name-error").text(data.error);
               $("#new-group-name-error").show();
             }
           })
           .fail(function() {
             console.error( "Cannot rename group" );
           });
}

function updateURLParameter(url, param, paramVal){
    var newAdditionalURL = "";
    var tempArray = url.split("?");
    var baseURL = tempArray[0];
    var additionalURL = tempArray[1];
    var temp = "";
    if (additionalURL) {
        tempArray = additionalURL.split("&");
        for (var i=0; i<tempArray.length; i++){
            if(tempArray[i].split('=')[0] != param){
                newAdditionalURL += temp + tempArray[i];
                temp = "&";
            }
        }
    }

    var rows_txt = temp + "" + param + "=" + paramVal;
    return baseURL + "?" + newAdditionalURL + rows_txt;
}